namespace concerto.metamodel;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Position")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Position : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Position";
   public int line { get; set; }
   public int column { get; set; }
   public int offset { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Range")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Range : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Range";
   public Position start { get; set; }
   public Position end { get; set; }
   public string source { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "TypeIdentifier")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class TypeIdentifier : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.TypeIdentifier";
   public string name { get; set; }
   [System.Text.Json.Serialization.JsonPropertyName("namespace")]
   public string _namespace { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DecoratorLiteral")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class DecoratorLiteral : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DecoratorLiteral";
   public Range? location { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DecoratorString")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DecoratorString : DecoratorLiteral {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DecoratorString";
   public string value { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DecoratorNumber")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DecoratorNumber : DecoratorLiteral {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DecoratorNumber";
   public float value { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DecoratorBoolean")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DecoratorBoolean : DecoratorLiteral {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DecoratorBoolean";
   public bool value { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DecoratorTypeReference")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DecoratorTypeReference : DecoratorLiteral {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DecoratorTypeReference";
   public TypeIdentifier type { get; set; }
   public bool isArray { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Decorator")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Decorator : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Decorator";
   public string name { get; set; }
   public DecoratorLiteral?[] arguments { get; set; }
   public Range? location { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Identified")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Identified : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Identified";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "IdentifiedBy")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class IdentifiedBy : Identified {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.IdentifiedBy";
   public string name { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Declaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Declaration : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Declaration";
   public string name { get; set; }
   public Decorator?[] decorators { get; set; }
   public Range? location { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "EnumDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EnumDeclaration : Declaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.EnumDeclaration";
   public EnumProperty[] properties { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "EnumProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EnumProperty : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.EnumProperty";
   public string name { get; set; }
   public Decorator?[] decorators { get; set; }
   public Range? location { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "ConceptDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ConceptDeclaration : Declaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.ConceptDeclaration";
   public bool isAbstract { get; set; }
   public Identified? identified { get; set; }
   public TypeIdentifier? superType { get; set; }
   public Property[] properties { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "AssetDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class AssetDeclaration : ConceptDeclaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.AssetDeclaration";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "ParticipantDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ParticipantDeclaration : ConceptDeclaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.ParticipantDeclaration";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "TransactionDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class TransactionDeclaration : ConceptDeclaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.TransactionDeclaration";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "EventDeclaration")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EventDeclaration : ConceptDeclaration {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.EventDeclaration";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Property")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Property : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Property";
   public string name { get; set; }
   public bool isArray { get; set; }
   public bool isOptional { get; set; }
   public Decorator?[] decorators { get; set; }
   public Range? location { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "RelationshipProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class RelationshipProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.RelationshipProperty";
   public TypeIdentifier type { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "ObjectProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ObjectProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.ObjectProperty";
   public string defaultValue { get; set; }
   public TypeIdentifier type { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "BooleanProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class BooleanProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.BooleanProperty";
   public bool? defaultValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DateTimeProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DateTimeProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DateTimeProperty";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "StringProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class StringProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.StringProperty";
   public string defaultValue { get; set; }
   public StringRegexValidator? validator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "StringRegexValidator")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class StringRegexValidator : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.StringRegexValidator";
   public string pattern { get; set; }
   public string flags { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DoubleProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DoubleProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DoubleProperty";
   public float? defaultValue { get; set; }
   public DoubleDomainValidator? validator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "DoubleDomainValidator")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DoubleDomainValidator : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.DoubleDomainValidator";
   public float? lower { get; set; }
   public float? upper { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "IntegerProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class IntegerProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.IntegerProperty";
   public int? defaultValue { get; set; }
   public IntegerDomainValidator? validator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "IntegerDomainValidator")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class IntegerDomainValidator : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.IntegerDomainValidator";
   public int? lower { get; set; }
   public int? upper { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "LongProperty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class LongProperty : Property {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.LongProperty";
   public long? defaultValue { get; set; }
   public LongDomainValidator? validator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "LongDomainValidator")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class LongDomainValidator : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.LongDomainValidator";
   public long? lower { get; set; }
   public long? upper { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Import")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Import : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Import";
   [System.Text.Json.Serialization.JsonPropertyName("namespace")]
   public string _namespace { get; set; }
   public string uri { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "ImportAll")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ImportAll : Import {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.ImportAll";
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "ImportType")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ImportType : Import {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.ImportType";
   public string name { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Model")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Model : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Model";
   [System.Text.Json.Serialization.JsonPropertyName("namespace")]
   public string _namespace { get; set; }
   public string sourceUri { get; set; }
   public string concertoVersion { get; set; }
   public Import?[] imports { get; set; }
   public Declaration?[] declarations { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "concerto.metamodel", Version = "0.4.0", Name = "Models")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Models : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "concerto.metamodel@0.4.0.Models";
   public Model[] models { get; set; }
}
